/*
 *  seznam.h
 *  Created by Helena Červinková on 10.5.06.
 */

#pragma once
#include <iostream>
#include <string.h>
using namespace std;

class seznam {
protected:
	seznam * predchudce, * naslednik;
	virtual int porovnej (seznam* prvek1,seznam* prvek2) = 0; //porovnání dvou prvků seznamu
private:
	void inicializace(); //vytvoření prázdného seznamu
	bool je_prazdny() const; //test ne/prázdnosti seznamu
	seznam* zrus_bod_bez_nasledniku (seznam* predchudce, seznam* bod); // bod z konce seznamu
	seznam* zrus_bod_s_naslednikem  (seznam* predchudce, seznam* bod); // existuje naslednik bodu
	seznam * vrat_hodnotu(); //vrací hodnotu aktuálního prvku, zpristupneni nějakého bodu
public:
	seznam() { predchudce = 0; naslednik= 0;};
	virtual ~seznam() {;}
	virtual void vypis () const { ;}
	virtual void uloz_do_souboru(const char * jmeno_souboru) const { ; }
	void vloz_za_prvek(); //vkládá za aktuální prvek nebo snad použít ->  seznam* vloz (seznam* novy_bod);
	void uprav_prvek(); //aktualizace stávajícího aktuálního prvku
	seznam* najdi_bod (seznam* bod);
	seznam* smaz_bod (seznam* hledany_bod);
};